Subject: Re: [bug#49149] [PATCH 0/7] Add deb format for guix pack.

From: Maxim Cournoyer <[email-masked]>
Date: Wed, 30 Jun 2021 15:20:00 -0400

Hi Simon,

zimoun <[email-masked]> writes:

> Hi Maxim,
>
> On Wed, 30 Jun 2021 at 13:28, Maxim Cournoyer <[email-masked]> wrote:
>> --8<---------------cut here---------------start------------->8---
>> doc: Add a note and warning regarding the usage of deb packs.
>
> [...]
>
>> +@item deb
>> +This produces a Debian archive (a package with the @samp{.deb} file
>> +extension) containing all the specified binaries and symbolic links,
>> +that can be installed on top of any dpkg-based GNU/Linux distribution.
>> +
>> +@quotation Note
>> +Because archives produced with @command{guix pack} contain a collection
>> +of store items and because each @command{dpkg} package must not have
>> +conflicting files, in practice that means you likely won't be able to
>> +install more one such archive on the same system.
>> +@end quotation
>> +
>> +@quotation Warning
>> +@command{dpkg} will assume ownership of any files contained in the pack
>> +that it does @emph{not} know about.  It is unwise to install
>> +Guix-produced @samp{.deb} files on a system where @file{/gnu/store} is
>> +shared by other software, such as a Guix installation or other, non-deb
>> +packs.
>> +@end quotation
>> +
>>  @end table
>>  
>>  @cindex relocatable binaries
>> --8<---------------cut here---------------end--------------->8---
>
> The pack does not fully respect the FHS from the Debian Policy, right?
>
> Hum, the disclaim LGTM.  Although, it appears to me a severe limitation
> to be able to install only one Guix-generated .deb pack on a Debian-like
> system, IIUC. :-)

Thanks!  It is!  One thing that would be possible is react to a user
passing the -R(R) (relocatable) option and keep the deb pack contents
under a named prefix, such as /opt/deb-packs/name/gnu/store/[...] to
keep them from conflicting.  I won't be pursuing it myself but it
shouldn't be too difficult to do!

Maxim